﻿Option Explicit On
Option Infer On

Imports System.Collections.Generic

Public Class _Default
    Inherits System.Web.UI.Page

    Dim nEntity As New NorthwindEntities()

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            BindGrid()
        End If
    End Sub

    Private Sub BindGrid()
        gvDetails.DataSource = GetCustomers()
        gvDetails.DataBind()
    End Sub

    Private Function GetCustomers() As List(Of Customer)
        Return nEntity.Customers.ToList()
    End Function

    Protected Sub gvDetails_PageIndexChanging(sender As Object, e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles gvDetails.PageIndexChanging
        gvDetails.PageIndex = e.NewPageIndex
        BindGrid()
    End Sub

    Protected Sub gvDetails_RowCancelingEdit(sender As Object, e As System.Web.UI.WebControls.GridViewCancelEditEventArgs) Handles gvDetails.RowCancelingEdit
        gvDetails.EditIndex = -1
        BindGrid()
    End Sub

    Protected Sub gvDetails_RowCreated(sender As Object, e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles gvDetails.RowCreated
        For Each cell As TableCell In e.Row.Cells
            If ((Not String.IsNullOrEmpty(cell.Text)) And (cell.Text <> "&nbsp;")) Then
                Dim fld As BoundField
                fld = DirectCast(DirectCast(cell, DataControlFieldCell).ContainingField, BoundField)
                If fld.DataField = "CustomerID" Then
                    fld.ReadOnly = True
                End If
            End If
        Next
    End Sub

    Protected Sub gvDetails_RowEditing(sender As Object, e As System.Web.UI.WebControls.GridViewEditEventArgs) Handles gvDetails.RowEditing
        gvDetails.EditIndex = e.NewEditIndex
        BindGrid()
    End Sub

    Protected Sub gvDetails_RowUpdating(sender As Object, e As System.Web.UI.WebControls.GridViewUpdateEventArgs) Handles gvDetails.RowUpdating

        'No Updates code for now..You may supply updates code here...

        gvDetails.EditIndex = -1
        BindGrid()
    End Sub
End Class